/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 11 "trafgen_parser.y" /* yacc.c:339  */


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <errno.h>
#include <libgen.h>
#include <signal.h>
#include <unistd.h>
#include <net/if_arp.h>
#include <netinet/in.h>
#include <linux/icmp.h>
#include <linux/if_ether.h>
#include <linux/icmpv6.h>

#include "xmalloc.h"
#include "trafgen_parser.tab.h"
#include "trafgen_conf.h"
#include "trafgen_proto.h"
#include "trafgen_l2.h"
#include "trafgen_l3.h"
#include "trafgen_l4.h"
#include "built_in.h"
#include "die.h"
#include "str.h"
#include "csum.h"
#include "cpp.h"

#ifndef ETH_P_8021AD
#define ETH_P_8021AD	0x88A8
#endif

#define YYERROR_VERBOSE		0
#define YYDEBUG			0
#define YYENABLE_NLS		1
#define YYLTYPE_IS_TRIVIAL	1
#define ENABLE_NLS		1

extern FILE *yyin;
extern int yylex(void);
extern void yy_scan_string(char *);
extern void yylex_destroy();
extern void yyerror(const char *);
extern int yylineno;
extern char *yytext;

extern struct packet *packets;
extern size_t plen;

#define packet_last		(plen - 1)

#define payload_last		(packets[packet_last].len - 1)

extern struct packet_dyn *packet_dyn;
extern size_t dlen;

#define packetd_last		(dlen - 1)

#define packetdc_last		(packet_dyn[packetd_last].clen - 1)
#define packetdr_last		(packet_dyn[packetd_last].rlen - 1)
#define packetds_last		(packet_dyn[packetd_last].slen - 1)

static int our_cpu, min_cpu = -1, max_cpu = -1;

enum field_expr_type_t {
	FIELD_EXPR_UNKNOWN	= 0,
	FIELD_EXPR_NUMB		= 1 << 0,
	FIELD_EXPR_MAC		= 1 << 1,
	FIELD_EXPR_IP4_ADDR	= 1 << 2,
	FIELD_EXPR_IP6_ADDR	= 1 << 3,
	FIELD_EXPR_INC		= 1 << 4,
	FIELD_EXPR_RND		= 1 << 5,
	FIELD_EXPR_OFFSET	= 1 << 6,
};

struct proto_field_expr {
	enum field_expr_type_t type;
	struct proto_field *field;

	union {
		struct in_addr ip4_addr;
		struct in6_addr ip6_addr;
		long long int number;
		uint8_t mac[256];
		struct proto_field_func func;
	} val;
};

static struct proto_field_expr field_expr;
static struct proto_hdr *hdr;

static inline int test_ignore(void)
{
	if (min_cpu < 0 && max_cpu < 0)
		return 0;
	else if (max_cpu >= our_cpu && min_cpu <= our_cpu)
		return 0;
	else
		return 1;
}

static inline void __init_new_packet_slot(struct packet *slot)
{
	memset(slot, 0, sizeof(*slot));
}

static inline void __init_new_counter_slot(struct packet_dyn *slot)
{
	slot->cnt = NULL;
	slot->clen = 0;
}

static inline void __init_new_randomizer_slot(struct packet_dyn *slot)
{
	slot->rnd = NULL;
	slot->rlen = 0;
}

static inline void __init_new_csum_slot(struct packet_dyn *slot)
{
	slot->csum = NULL;
	slot->slen = 0;
}

static inline void __init_new_fields_slot(struct packet_dyn *slot)
{
	slot->fields = NULL;
	slot->flen = 0;
}

static inline void __setup_new_counter(struct counter *c, uint8_t start,
				       uint8_t stop, uint8_t stepping,
				       int type)
{
	c->min = start;
	c->max = stop;
	c->inc = stepping;
	c->val = (type == TYPE_INC) ? start : stop;
	c->off = payload_last;
	c->type = type;
}

static inline void __setup_new_randomizer(struct randomizer *r)
{
	r->off = payload_last;
}

static inline void __setup_new_csum16(struct csum16 *s, off_t from, off_t to,
				      enum csum which)
{
	s->off = payload_last - 1;
	s->from = from;
	s->to = to;
	s->which = which;
}

void realloc_packet(void)
{
	if (test_ignore())
		return;

	plen++;
	packets = xrealloc(packets, plen * sizeof(*packets));

	__init_new_packet_slot(&packets[packet_last]);

	dlen++;
	packet_dyn = xrealloc(packet_dyn, dlen * sizeof(*packet_dyn));

	__init_new_counter_slot(&packet_dyn[packetd_last]);
	__init_new_randomizer_slot(&packet_dyn[packetd_last]);
	__init_new_csum_slot(&packet_dyn[packetd_last]);
	__init_new_fields_slot(&packet_dyn[packetd_last]);
}

struct packet *current_packet(void)
{
	return &packets[packet_last];
}

uint32_t current_packet_id(void)
{
	return packet_last;
}

struct packet *packet_get(uint32_t id)
{
	return &packets[id];
}

static void set_byte(uint8_t val)
{
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	pkt->payload[payload_last] = val;
}

static void set_multi_byte(uint8_t *s, size_t len)
{
	size_t i;

	for (i = 0; i < len; ++i)
		set_byte(s[i]);
}

void set_fill(uint8_t val, size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = val;
}

static void __set_csum16_dynamic(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	pkt->len += 2;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->slen++;
	pktd->csum = xrealloc(pktd->csum, pktd->slen * sizeof(struct csum16));

	__setup_new_csum16(&pktd->csum[packetds_last], from, to, which);
}

static void __set_csum16_static(size_t from, size_t to, enum csum which __maybe_unused)
{
	struct packet *pkt = &packets[packet_last];
	uint16_t sum;
	uint8_t *psum;

	sum = htons(calc_csum(pkt->payload + from, to - from));
	psum = (uint8_t *) &sum;

	set_byte(psum[0]);
	set_byte(psum[1]);
}

static inline bool is_dynamic_csum(enum csum which)
{
	switch (which) {
	case CSUM_UDP:
	case CSUM_TCP:
	case CSUM_UDP6:
	case CSUM_TCP6:
		return true;
	default:
		return false;
	}
}

static void set_csum16(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	if (to < from) {
		size_t tmp = to;

		to = from;
		from = tmp;
	}

	bug_on(!(from < to));

	if (packet_dyn_has_elems(pktd) || to >= pkt->len || is_dynamic_csum(which))
		__set_csum16_dynamic(from, to, which);
	else
		__set_csum16_static(from, to, which);
}

static void set_rnd(size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = (uint8_t) rand();
}

static void set_sequential_inc(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		off_t off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start += stepping;
	}
}

static void set_sequential_dec(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		int off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start -= stepping;
	}
}

static void set_dynamic_rnd(void)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->rlen++;
	pktd->rnd = xrealloc(pktd->rnd, pktd->rlen * sizeof(struct randomizer));

	__setup_new_randomizer(&pktd->rnd[packetdr_last]);
}

static void set_dynamic_incdec(uint8_t start, uint8_t stop, uint8_t stepping,
			       int type)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->clen++;
	pktd->cnt = xrealloc(pktd->cnt, pktd->clen * sizeof(struct counter));

	__setup_new_counter(&pktd->cnt[packetdc_last], start, stop, stepping, type);
}

static void proto_add(enum proto_id pid)
{
	hdr = proto_header_push(pid);
}

static void proto_field_set(uint32_t fid)
{
	memset(&field_expr, 0, sizeof(field_expr));
	field_expr.field = proto_hdr_field_by_id(hdr, fid);
}

static void proto_field_func_setup(struct proto_field *field, struct proto_field_func *func)
{
	struct proto_field *field_copy;
	struct packet_dyn *pkt_dyn;

	field_copy = xmalloc(sizeof(*field));
	memcpy(field_copy, field, sizeof(*field));

	field_copy->pkt_offset += func->offset;
	if (func->len)
		field_copy->len = func->len;

	proto_field_func_add(field_copy, func);

	pkt_dyn = &packet_dyn[packetd_last];
	pkt_dyn->flen++;
	pkt_dyn->fields = xrealloc(pkt_dyn->fields, pkt_dyn->flen *
				   sizeof(struct proto_field *));

	pkt_dyn->fields[pkt_dyn->flen - 1] = field_copy;
}

static void proto_field_expr_eval(void)
{
	struct proto_field *field = field_expr.field;

	if ((field_expr.type & FIELD_EXPR_OFFSET) &&
			!((field_expr.type & FIELD_EXPR_INC) ||
				(field_expr.type & FIELD_EXPR_RND))) {

		panic("Field offset expression is valid only with function expression\n");
	}

	if (field_expr.type & FIELD_EXPR_NUMB) {
		if (field->len == 1)
			proto_hdr_field_set_u8(hdr, field->id, field_expr.val.number);
		else if (field->len == 2)
			proto_hdr_field_set_be16(hdr, field->id, field_expr.val.number);
		else if (field->len == 4)
			proto_hdr_field_set_be32(hdr, field->id, field_expr.val.number);
		else
			panic("Invalid value length %zu, can be 1,2 or 4\n", field->len);
	} else if (field_expr.type & FIELD_EXPR_MAC) {
		proto_hdr_field_set_bytes(hdr, field->id, field_expr.val.mac);
	} else if (field_expr.type & FIELD_EXPR_IP4_ADDR) {
		proto_hdr_field_set_u32(hdr, field->id, field_expr.val.ip4_addr.s_addr);
	} else if (field_expr.type & FIELD_EXPR_IP6_ADDR) {
		proto_hdr_field_set_bytes(hdr, field->id,
			(uint8_t *)&field_expr.val.ip6_addr.s6_addr);
	} else if ((field_expr.type & FIELD_EXPR_INC) ||
			(field_expr.type & FIELD_EXPR_RND)) {

		if (field_expr.val.func.min
			&& field_expr.val.func.min >= field_expr.val.func.max)
			panic("dinc(): min(%u) can't be >= max(%u)\n",
				field_expr.val.func.min, field_expr.val.func.max);

		proto_field_func_setup(field, &field_expr.val.func);
	} else if ((field_expr.type & FIELD_EXPR_OFFSET) &&
			!((field_expr.type & FIELD_EXPR_INC) ||
				(field_expr.type & FIELD_EXPR_RND))) {

		panic("Field expression is valid only for function value expression\n");
	} else {
		bug();
	}

	memset(&field_expr, 0, sizeof(field_expr));
}

static void field_index_validate(struct proto_field *field, uint16_t index, size_t len)
{
	if (field_expr.field->len <= index) {
		yyerror("Invalid [index] parameter");
		panic("Index (%u) is bigger than field's length (%zu)\n",
		       index, field->len);
	}
	if (len != 1 && len != 2 && len != 4) {
		yyerror("Invalid [index:len] parameter");
		panic("Invalid index length - 1,2 or 4 is only allowed\n");
	}
}


#line 535 "trafgen/trafgen_parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "trafgen_parser.tab.h".  */
#ifndef YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
# define YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    K_COMMENT = 258,
    K_FILL = 259,
    K_RND = 260,
    K_SEQINC = 261,
    K_SEQDEC = 262,
    K_DRND = 263,
    K_DINC = 264,
    K_DDEC = 265,
    K_WHITE = 266,
    K_CPU = 267,
    K_CSUMIP = 268,
    K_CSUMUDP = 269,
    K_CSUMTCP = 270,
    K_CSUMUDP6 = 271,
    K_CSUMTCP6 = 272,
    K_CONST8 = 273,
    K_CONST16 = 274,
    K_CONST32 = 275,
    K_CONST64 = 276,
    K_DADDR = 277,
    K_SADDR = 278,
    K_ETYPE = 279,
    K_TYPE = 280,
    K_TIME = 281,
    K_PRIO = 282,
    K_OPER = 283,
    K_SHA = 284,
    K_SPA = 285,
    K_THA = 286,
    K_TPA = 287,
    K_REQUEST = 288,
    K_REPLY = 289,
    K_PTYPE = 290,
    K_HTYPE = 291,
    K_PROT = 292,
    K_TTL = 293,
    K_DSCP = 294,
    K_ECN = 295,
    K_TOS = 296,
    K_LEN = 297,
    K_ID = 298,
    K_FLAGS = 299,
    K_FRAG = 300,
    K_IHL = 301,
    K_VER = 302,
    K_CSUM = 303,
    K_DF = 304,
    K_MF = 305,
    K_FLOW = 306,
    K_NEXT_HDR = 307,
    K_HOP_LIMIT = 308,
    K_CODE = 309,
    K_ECHO_REQUEST = 310,
    K_ECHO_REPLY = 311,
    K_SPORT = 312,
    K_DPORT = 313,
    K_SEQ = 314,
    K_ACK_SEQ = 315,
    K_DOFF = 316,
    K_CWR = 317,
    K_ECE = 318,
    K_URG = 319,
    K_ACK = 320,
    K_PSH = 321,
    K_RST = 322,
    K_SYN = 323,
    K_FIN = 324,
    K_WINDOW = 325,
    K_URG_PTR = 326,
    K_TPID = 327,
    K_TCI = 328,
    K_PCP = 329,
    K_DEI = 330,
    K_1Q = 331,
    K_1AD = 332,
    K_LABEL = 333,
    K_TC = 334,
    K_LAST = 335,
    K_EXP = 336,
    K_ADDR = 337,
    K_MTU = 338,
    K_ETH = 339,
    K_PAUSE = 340,
    K_PFC = 341,
    K_VLAN = 342,
    K_MPLS = 343,
    K_ARP = 344,
    K_IP4 = 345,
    K_IP6 = 346,
    K_ICMP4 = 347,
    K_ICMP6 = 348,
    K_UDP = 349,
    K_TCP = 350,
    number = 351,
    string = 352,
    mac = 353,
    ip4_addr = 354,
    ip6_addr = 355
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 480 "trafgen_parser.y" /* yacc.c:355  */

	struct in_addr ip4_addr;
	struct in6_addr ip6_addr;
	long long int number;
	uint8_t mac[6];
	char *str;

#line 684 "trafgen/trafgen_parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 701 "trafgen/trafgen_parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   565

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  120
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  89
/* YYNRULES -- Number of rules.  */
#define YYNRULES  279
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  568

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   355

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   108,   109,     2,
      99,   100,   106,   105,    96,   104,     2,   107,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   103,     2,
     111,   119,   112,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   101,     2,   102,   113,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    97,   110,    98,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,   114,   115,   116,   117,   118
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   528,   528,   529,   530,   531,   535,   539,   540,   544,
     545,   549,   550,   551,   555,   556,   559,   566,   581,   591,
     592,   596,   597,   601,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   621,   623,   625,
     627,   629,   631,   633,   635,   637,   639,   641,   643,   645,
     650,   655,   657,   662,   667,   675,   680,   682,   684,   686,
     688,   693,   695,   700,   702,   707,   709,   718,   720,   725,
     727,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   747,   752,   760,   762,   764,   766,   768,
     771,   775,   782,   789,   791,   799,   803,   807,   808,   809,
     813,   814,   815,   819,   820,   821,   824,   826,   831,   835,
     839,   840,   841,   845,   846,   850,   852,   857,   861,   865,
     866,   867,   871,   872,   873,   879,   888,   890,   895,   899,
     903,   904,   905,   909,   910,   914,   915,   916,   917,   918,
     922,   924,   926,   928,   933,   937,   941,   942,   943,   947,
     948,   952,   953,   954,   955,   959,   961,   966,   970,   971,
     972,   976,   978,   980,   982,   984,   986,   991,   993,   995,
     998,  1001,  1003,  1005,  1007,  1012,  1016,  1020,  1021,  1022,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1043,  1045,  1047,  1048,  1052,  1056,
    1060,  1061,  1062,  1066,  1067,  1071,  1072,  1073,  1074,  1075,
    1076,  1077,  1078,  1082,  1084,  1089,  1093,  1097,  1098,  1099,
    1103,  1104,  1105,  1106,  1107,  1108,  1112,  1114,  1116,  1119,
    1125,  1129,  1133,  1134,  1135,  1139,  1140,  1144,  1146,  1148,
    1151,  1154,  1156,  1158,  1160,  1164,  1168,  1172,  1173,  1174,
    1178,  1179,  1180,  1181,  1185,  1187,  1192,  1196,  1200,  1201,
    1202,  1206,  1207,  1208,  1209,  1210,  1211,  1212,  1213,  1217,
    1219,  1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1232
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_COMMENT", "K_FILL", "K_RND",
  "K_SEQINC", "K_SEQDEC", "K_DRND", "K_DINC", "K_DDEC", "K_WHITE", "K_CPU",
  "K_CSUMIP", "K_CSUMUDP", "K_CSUMTCP", "K_CSUMUDP6", "K_CSUMTCP6",
  "K_CONST8", "K_CONST16", "K_CONST32", "K_CONST64", "K_DADDR", "K_SADDR",
  "K_ETYPE", "K_TYPE", "K_TIME", "K_PRIO", "K_OPER", "K_SHA", "K_SPA",
  "K_THA", "K_TPA", "K_REQUEST", "K_REPLY", "K_PTYPE", "K_HTYPE", "K_PROT",
  "K_TTL", "K_DSCP", "K_ECN", "K_TOS", "K_LEN", "K_ID", "K_FLAGS",
  "K_FRAG", "K_IHL", "K_VER", "K_CSUM", "K_DF", "K_MF", "K_FLOW",
  "K_NEXT_HDR", "K_HOP_LIMIT", "K_CODE", "K_ECHO_REQUEST", "K_ECHO_REPLY",
  "K_SPORT", "K_DPORT", "K_SEQ", "K_ACK_SEQ", "K_DOFF", "K_CWR", "K_ECE",
  "K_URG", "K_ACK", "K_PSH", "K_RST", "K_SYN", "K_FIN", "K_WINDOW",
  "K_URG_PTR", "K_TPID", "K_TCI", "K_PCP", "K_DEI", "K_1Q", "K_1AD",
  "K_LABEL", "K_TC", "K_LAST", "K_EXP", "K_ADDR", "K_MTU", "K_ETH",
  "K_PAUSE", "K_PFC", "K_VLAN", "K_MPLS", "K_ARP", "K_IP4", "K_IP6",
  "K_ICMP4", "K_ICMP6", "K_UDP", "K_TCP", "','", "'{'", "'}'", "'('",
  "')'", "'['", "']'", "':'", "'-'", "'+'", "'*'", "'/'", "'%'", "'&'",
  "'|'", "'<'", "'>'", "'^'", "number", "string", "mac", "ip4_addr",
  "ip6_addr", "'='", "$accept", "packets", "inline_comment", "cpu_delim",
  "delimiter_nowhite", "noenforce_white", "skip_white", "packet",
  "payload", "delimiter", "elem_delimiter", "elem", "expression", "fill",
  "const", "rnd", "csum", "seqinc", "seqdec", "drnd", "dinc", "ddec",
  "proto", "field_expr", "field_value_expr", "eth_proto", "eth",
  "eth_param_list", "eth_type", "eth_field", "eth_expr", "pause_proto",
  "pause", "pause_param_list", "pause_field", "pause_expr", "pfc_proto",
  "pfc", "pfc_param_list", "pfc_field", "pfc_expr", "vlan_proto", "vlan",
  "vlan_param_list", "vlan_type", "vlan_field", "vlan_expr", "mpls_proto",
  "mpls", "mpls_param_list", "mpls_tc", "mpls_field", "mpls_expr",
  "arp_proto", "arp_param_list", "arp_field", "arp_expr", "arp",
  "ip4_proto", "ip4_param_list", "ip4_field", "ip4_expr", "ip4",
  "ip6_proto", "ip6_param_list", "ip6_hop_limit", "ip6_field", "ip6_expr",
  "ip6", "icmp4_proto", "icmp4_param_list", "icmp4_field", "icmp4_expr",
  "icmp4", "icmpv6_proto", "icmp6_param_list", "icmp6_field", "icmp6_expr",
  "icmp6", "udp_proto", "udp_param_list", "udp_field", "udp_expr", "udp",
  "tcp_proto", "tcp_param_list", "tcp_field", "tcp_expr", "tcp", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,    44,   123,   125,    40,
      41,    91,    93,    58,    45,    43,    42,    47,    37,    38,
     124,    60,    62,    94,   351,   352,   353,   354,   355,    61
};
# endif

#define YYPACT_NINF -423

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-423)))

#define YYTABLE_NINF -14

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -423,    19,  -423,  -423,  -423,   -82,    24,  -423,  -423,   -78,
    -423,    31,  -423,   141,   -15,  -423,   -22,   -18,    -9,     1,
      16,    23,    27,    29,    41,    53,    69,    77,    78,    82,
      83,    84,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,    33,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
      86,  -423,    87,  -423,    88,  -423,    90,  -423,    91,  -423,
      92,  -423,    94,  -423,    95,  -423,    97,  -423,    98,  -423,
     100,  -423,   101,   -31,  -423,  -423,    -2,    93,   103,   104,
     105,   -39,   107,   108,   109,   123,   130,   135,   137,   -81,
     -81,   -81,   -81,   106,   110,   113,   141,  -423,   278,     8,
       2,   166,   -13,   366,   445,   424,   381,    15,   122,   448,
      24,   112,    34,   114,    34,    34,  -423,   115,    34,    34,
      34,    34,    34,    34,    34,   -81,   -81,  -423,   239,   344,
     420,   438,  -423,  -423,  -423,  -423,  -423,  -423,  -423,   152,
    -423,    -8,    34,  -423,  -423,   154,    -8,    34,   102,   158,
    -423,   159,    -8,    34,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,   160,  -423,    -8,    34,  -423,  -423,  -423,  -423,
    -423,   162,  -423,    -8,    34,    -8,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,   163,    -8,    34,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,   165,    -8,    34,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,   168,  -423,    -8,    34,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,   170,    -8,    34,
      -8,  -423,  -423,  -423,  -423,   171,    -8,    34,  -423,  -423,
    -423,  -423,   173,    -8,    34,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,   174,    -8,    34,    -1,    38,  -423,  -423,   183,  -423,
     184,   190,  -423,   191,   192,   193,   194,   195,   197,   199,
     452,  -423,  -423,   -81,   -81,   -81,   -81,   -81,   -81,   -81,
     155,   164,   -81,  -423,  -423,  -423,  -423,  -423,   266,   161,
     266,   278,  -423,   169,   266,     8,   205,   207,  -423,   204,
     266,     2,  -423,   206,   266,   166,  -423,   208,   266,   -13,
     210,   266,  -423,   212,   266,   366,  -423,   214,   266,   445,
    -423,   215,   266,   424,  -423,   216,   266,   381,   218,   266,
    -423,   222,   266,    15,  -423,   234,   266,   122,  -423,   235,
     266,   448,    24,    24,   179,    13,    35,    42,    43,   182,
     185,   187,   255,   258,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,   -81,   -81,  -423,   246,   266,   242,  -423,   266,
     243,  -423,   264,   268,   266,   247,  -423,   266,   251,  -423,
     266,   253,  -423,   266,   257,   266,   259,  -423,   266,   263,
    -423,   266,   265,  -423,   266,   267,  -423,    -4,   269,   266,
     270,  -423,   266,   271,  -423,   266,   272,  -423,   141,   277,
    -423,  -423,   290,  -423,   294,  -423,   296,  -423,   298,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,   266,     7,   266,     7,
     266,  -423,  -423,     7,   266,     7,   266,     7,   266,    49,
     266,     7,   266,     7,   266,     7,   266,     7,   266,  -423,
    -423,     7,   266,     7,   266,     7,   266,     7,   266,    33,
      24,   292,   313,   314,   316,     4,   321,   323,  -423,  -423,
    -423,  -423,  -423,     7,  -423,     7,  -423,     7,  -423,     7,
    -423,     7,  -423,  -423,  -423,     7,  -423,     7,  -423,     7,
    -423,     7,  -423,     7,  -423,     7,  -423,     7,  -423,     7,
    -423,     7,   186,   141,  -423,  -423,  -423,  -423,  -423,   266,
     -27,   -20,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,    33,   312,  -423,
      34,  -423,    73,   330,   266,   324,  -423,   325,  -423,   340,
     343,    75,  -423,  -423,  -423,   331,   358,  -423
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     6,     5,     0,    11,     4,     3,     0,
      12,     9,    13,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    96,   109,   118,   129,   145,   175,   198,   215,
     230,   245,   256,   279,    24,    25,    36,    11,    19,    26,
      34,    27,    33,    29,    30,    28,    31,    32,    35,    71,
       0,    72,     0,    73,     0,    74,     0,    75,     0,    76,
       0,    77,     0,    78,     0,    79,     0,    80,     0,    81,
       0,    82,     0,     0,     7,     8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    22,    21,     0,     0,    20,    97,   110,
     119,   130,   146,   158,   177,   200,   217,   232,   247,   258,
      11,     0,     0,     0,     0,     0,    65,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,     0,
       0,     0,    16,    23,   103,   104,   100,   101,   102,     0,
     105,    14,    98,   114,   113,     0,    14,   111,     0,   123,
     122,     0,    14,   120,   134,   139,   133,   136,   137,   138,
     142,   143,     0,   135,    14,   131,   154,   151,   149,   153,
     150,     0,   152,    14,   147,    14,   163,   165,   164,   166,
     173,   174,   162,   161,     0,    14,   159,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   181,   180,
     193,   196,   197,     0,    14,   178,   212,   211,   204,   208,
     205,   207,   209,   203,   206,     0,   210,    14,   201,   220,
     222,   221,   228,   229,   223,   225,   224,     0,    14,   218,
      14,   236,   235,   242,   244,     0,    14,   233,   252,   253,
     250,   251,     0,    14,   248,   267,   261,   262,   263,   264,
     265,   271,   272,   273,   274,   275,   276,   277,   278,   266,
     268,     0,    14,   259,     0,     0,    22,    21,     0,    55,
       0,     0,    66,     0,     0,     0,     0,     0,     0,     0,
       0,    48,    51,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    52,    53,    54,    95,    15,    14,     0,
      14,    97,   108,     0,    14,   110,     0,     0,   117,     0,
      14,   119,   128,     0,    14,   130,   144,     0,    14,   146,
       0,    14,   157,     0,    14,   158,   176,     0,    14,   177,
     199,     0,    14,   200,   216,     0,    14,   217,     0,    14,
     231,     0,    14,   232,   246,     0,    14,   247,   257,     0,
      14,   258,    11,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,    39,    38,    40,    41,    42,
      43,    44,     0,     0,    45,     0,    14,     0,    99,    14,
       0,   112,     0,     0,    14,     0,   121,    14,     0,   132,
      14,     0,   148,    14,     0,    14,     0,   160,    14,     0,
     179,    14,     0,   202,    14,     0,   219,    14,     0,    14,
       0,   234,    14,     0,   249,    14,     0,   260,     0,     0,
      50,    61,     0,    63,     0,    67,     0,    69,     0,    56,
      58,    57,    60,    59,    46,    47,    14,     0,    14,     0,
      14,   125,   124,     0,    14,     0,    14,     0,    14,     0,
      14,     0,    14,     0,    14,     0,    14,     0,    14,   241,
     243,     0,    14,     0,    14,     0,    14,     0,    14,    11,
      11,     0,     0,     0,     0,     0,     0,     0,    85,    86,
      87,    88,   107,     0,   116,     0,   127,     0,   141,     0,
     156,     0,   171,   172,   170,     0,   168,     0,   195,     0,
     214,     0,   227,     0,   240,     0,   238,     0,   255,     0,
     270,     0,     0,     0,    62,    64,    68,    70,    83,    14,
       0,     0,   106,   115,   126,   140,   155,   169,   167,   194,
     213,   226,   239,   237,   254,   269,    18,    11,     0,    93,
       0,    89,     0,     0,    14,     0,    90,     0,    17,     0,
       0,     0,    84,    94,    91,     0,     0,    92
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -423,  -423,   458,  -423,    -6,   -46,  -136,  -423,  -422,  -120,
    -423,    99,    -3,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -135,   -90,  -423,  -423,   149,  -423,  -423,
    -423,  -423,  -423,   146,  -423,  -423,  -423,  -423,   144,  -423,
    -423,  -423,  -423,   145,  -423,  -423,  -423,  -423,  -423,   140,
    -423,  -423,  -423,  -423,   143,  -423,  -423,  -423,  -423,   133,
    -423,  -423,  -423,  -423,   136,  -423,  -423,  -423,  -423,  -423,
     134,  -423,  -423,  -423,  -423,   127,  -423,  -423,  -423,  -423,
     142,  -423,  -423,  -423,  -423,   139,  -423,  -423,  -423
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    46,    86,   277,    13,   309,     8,    47,   106,
     107,    48,   138,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,   310,   492,    59,    60,   149,   150,   151,
     152,    61,    62,   155,   156,   157,    63,    64,   161,   162,
     163,    65,    66,   172,   173,   174,   175,    67,    68,   181,
     182,   183,   184,    69,   194,   195,   196,    70,    71,   213,
     214,   215,    72,    73,   225,   226,   227,   228,    74,    75,
     237,   238,   239,    76,    77,   245,   246,   247,    78,    79,
     252,   253,   254,    80,    81,   271,   272,   273,    82
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      12,   105,   278,   307,   280,   281,   479,   307,   283,   284,
     285,   286,   287,   288,   289,   486,   487,     9,   135,     2,
     313,   314,     3,   136,   276,   176,   319,   320,   158,   159,
       4,     5,   311,   137,   153,    10,    14,   315,   323,   324,
     240,   104,    15,   321,   103,   276,   276,   327,   328,   330,
     331,   469,   470,   276,   276,   325,   160,   486,   487,   333,
     334,   126,   154,   241,   329,   177,   178,   179,   180,   242,
     243,   244,   120,   549,   274,   127,   335,    87,   337,   338,
     551,    88,   502,   503,   276,    83,   276,   550,    84,    85,
      89,   341,   342,   308,   552,   339,   362,   139,   140,   141,
      90,   547,   345,   346,   348,   349,   528,   529,   343,    11,
     351,   352,   121,   431,    12,    91,     6,   355,   356,   347,
      11,   488,    92,   489,   490,   491,    93,   353,    94,    11,
      11,    11,   290,   291,   357,   433,   359,   360,    11,    11,
      95,   363,   435,   437,     3,    16,    17,    18,    19,    20,
      21,    22,    96,   361,    23,    24,    25,    26,    27,    28,
      29,    30,    31,   488,   248,   489,   490,   491,    97,    11,
     249,    11,   385,   556,   387,   564,    98,    99,   390,   250,
     251,   100,   101,   102,   395,   108,   109,   110,   398,   111,
     112,   113,   401,   114,   115,   404,   116,   117,   406,   118,
     119,   316,   409,   164,   -12,   143,   412,   122,   -13,   165,
     415,   142,   275,   418,   279,   282,   420,   123,   124,   125,
     423,   128,   129,   130,   426,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,   131,   166,   167,
     168,   169,   170,   171,   132,   432,   434,   436,   438,   133,
     447,   134,   306,   449,   312,    44,    45,   317,   453,   318,
     322,   455,   326,   332,   457,   336,   382,   459,   340,   461,
     344,   350,   463,   354,   358,   465,   383,   307,   467,   430,
     386,   471,   439,   473,   546,   440,   475,   441,   389,   477,
     375,   376,   377,   378,   379,   380,   381,   364,   365,   384,
     144,   145,   146,   147,   366,   367,   368,   369,   370,   371,
     485,   372,   493,   373,   495,   148,   428,   429,   497,   392,
     499,   393,   501,   394,   505,   397,   507,   400,   509,   403,
     511,   405,   513,   408,   411,   414,   515,   417,   517,   292,
     519,   419,   521,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   422,   425,   442,    12,    12,   443,   494,
     446,   448,   450,   496,   451,   498,   454,   500,   452,   504,
     456,   506,   458,   508,   480,   510,   460,   512,   462,   444,
     445,   514,   464,   516,   466,   518,   468,   520,   472,   474,
     476,   478,   524,   548,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   532,   481,   533,   229,   534,   482,   535,
     483,   536,   484,   525,   526,   537,   527,   538,   559,   539,
     530,   540,   531,   541,   230,   542,   554,   543,   558,   544,
     555,   545,   557,   522,   523,   231,   232,   233,   560,   561,
     234,   565,   562,   563,   303,   566,   216,   217,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   567,     7,
     388,   391,   218,   235,   236,   396,   219,   197,   198,   402,
     399,   220,   410,   104,    12,   221,   222,   223,   407,   413,
     421,   416,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   255,     0,     0,   424,
     427,   553,     0,   224,     0,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     304,     0,     0,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,     0,     0,     0,     0,   305,     0,
       0,   104,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   374,     0,     0,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302
};

static const yytype_int16 yycheck[] =
{
       6,    47,   122,    11,   124,   125,   428,    11,   128,   129,
     130,   131,   132,   133,   134,     8,     9,    99,    99,     0,
     156,   156,     3,   104,    11,    38,   162,   162,    26,    27,
      11,    12,   152,   114,    26,    11,   114,   157,   174,   174,
      25,    47,    11,   163,    11,    11,    11,   183,   183,   185,
     185,    55,    56,    11,    11,   175,    54,     8,     9,   195,
     195,   100,    54,    48,   184,    78,    79,    80,    81,    54,
      55,    56,   103,   100,   120,   114,   196,    99,   214,   214,
     100,    99,    33,    34,    11,   100,    11,   114,   103,   104,
      99,   227,   227,   101,   114,   215,    97,   100,   101,   102,
      99,   523,   238,   238,   240,   240,   102,   103,   228,    96,
     246,   246,   114,   100,   120,    99,    97,   253,   253,   239,
      96,   114,    99,   116,   117,   118,    99,   247,    99,    96,
      96,    96,   135,   136,   254,   100,   272,   272,    96,    96,
      99,   103,   100,   100,     3,     4,     5,     6,     7,     8,
       9,    10,    99,   273,    13,    14,    15,    16,    17,    18,
      19,    20,    21,   114,    42,   116,   117,   118,    99,    96,
      48,    96,   308,   100,   310,   100,    99,    99,   314,    57,
      58,    99,    99,    99,   320,    99,    99,    99,   324,    99,
      99,    99,   328,    99,    99,   331,    99,    99,   334,    99,
      99,    99,   338,    37,    98,   106,   342,   114,    98,    43,
     346,    98,   100,   349,   100,   100,   352,   114,   114,   114,
     356,   114,   114,   114,   360,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,   114,    72,    73,
      74,    75,    76,    77,   114,   365,   366,   367,   368,   114,
     386,   114,   100,   389,   100,   114,   115,    99,   394,   100,
     100,   397,   100,   100,   400,   100,   111,   403,   100,   405,
     100,   100,   408,   100,   100,   411,   112,    11,   414,   100,
     119,   417,   100,   419,    98,   100,   422,   100,   119,   425,
     293,   294,   295,   296,   297,   298,   299,   114,   114,   302,
      22,    23,    24,    25,   114,   114,   114,   114,   114,   114,
     446,   114,   448,   114,   450,    37,   362,   363,   454,   114,
     456,   114,   458,   119,   460,   119,   462,   119,   464,   119,
     466,   119,   468,   119,   119,   119,   472,   119,   474,   100,
     476,   119,   478,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   119,   119,   100,   362,   363,   100,   449,
     114,   119,   119,   453,   100,   455,   119,   457,   100,   459,
     119,   461,   119,   463,    97,   465,   119,   467,   119,   382,
     383,   471,   119,   473,   119,   475,   119,   477,   119,   119,
     119,   119,   100,   529,    28,    29,    30,    31,    32,    33,
      34,    35,    36,   493,   114,   495,    25,   497,   114,   499,
     114,   501,   114,   100,   100,   505,   100,   507,   554,   509,
      99,   511,    99,   513,    43,   515,   114,   517,    98,   519,
     550,   521,   552,   479,   480,    54,    55,    56,   114,   114,
      59,   561,   102,   100,   100,   114,    22,    23,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   100,     1,
     311,   315,    38,    82,    83,   321,    42,    22,    23,   329,
     325,    47,   339,   479,   480,    51,    52,    53,   335,   343,
     353,   347,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    48,    -1,    -1,   357,
     361,   547,    -1,    79,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
     100,    -1,    -1,    -1,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,    -1,    -1,    -1,   100,    -1,
      -1,   547,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   100,    -1,    -1,    -1,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   121,     0,     3,    11,    12,    97,   122,   127,    99,
      11,    96,   124,   125,   114,    11,     4,     5,     6,     7,
       8,     9,    10,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,   114,   115,   122,   128,   131,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   145,
     146,   151,   152,   156,   157,   161,   162,   167,   168,   173,
     177,   178,   182,   183,   188,   189,   193,   194,   198,   199,
     203,   204,   208,   100,   103,   104,   123,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    11,   124,   125,   129,   130,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
     103,   114,   114,   114,   114,   114,   100,   114,   114,   114,
     114,   114,   114,   114,   114,    99,   104,   114,   132,   132,
     132,   132,    98,   131,    22,    23,    24,    25,    37,   147,
     148,   149,   150,    26,    54,   153,   154,   155,    26,    27,
      54,   158,   159,   160,    37,    43,    72,    73,    74,    75,
      76,    77,   163,   164,   165,   166,    38,    78,    79,    80,
      81,   169,   170,   171,   172,    28,    29,    30,    31,    32,
      33,    34,    35,    36,   174,   175,   176,    22,    23,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,   179,   180,   181,    22,    23,    38,    42,
      47,    51,    52,    53,    79,   184,   185,   186,   187,    25,
      43,    54,    55,    56,    59,    82,    83,   190,   191,   192,
      25,    48,    54,    55,    56,   195,   196,   197,    42,    48,
      57,    58,   200,   201,   202,    48,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,   205,   206,   207,   125,   100,    11,   124,   129,   100,
     129,   129,   100,   129,   129,   129,   129,   129,   129,   129,
     132,   132,   100,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   100,   100,   100,   100,    11,   101,   126,
     143,   129,   100,   126,   143,   129,    99,    99,   100,   126,
     143,   129,   100,   126,   143,   129,   100,   126,   143,   129,
     126,   143,   100,   126,   143,   129,   100,   126,   143,   129,
     100,   126,   143,   129,   100,   126,   143,   129,   126,   143,
     100,   126,   143,   129,   100,   126,   143,   129,   100,   126,
     143,   129,    97,   103,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   100,   132,   132,   132,   132,   132,
     132,   132,   111,   112,   132,   126,   119,   126,   147,   119,
     126,   153,   114,   114,   119,   126,   158,   119,   126,   163,
     119,   126,   169,   119,   126,   119,   126,   174,   119,   126,
     179,   119,   126,   184,   119,   126,   190,   119,   126,   119,
     126,   195,   119,   126,   200,   119,   126,   205,   125,   125,
     100,   100,   129,   100,   129,   100,   129,   100,   129,   100,
     100,   100,   100,   100,   132,   132,   114,   126,   119,   126,
     119,   100,   100,   126,   119,   126,   119,   126,   119,   126,
     119,   126,   119,   126,   119,   126,   119,   126,   119,    55,
      56,   126,   119,   126,   119,   126,   119,   126,   119,   128,
      97,   114,   114,   114,   114,   126,     8,     9,   114,   116,
     117,   118,   144,   126,   144,   126,   144,   126,   144,   126,
     144,   126,    33,    34,   144,   126,   144,   126,   144,   126,
     144,   126,   144,   126,   144,   126,   144,   126,   144,   126,
     144,   126,   125,   125,   100,   100,   100,   100,   102,   103,
      99,    99,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,    98,   128,   126,   100,
     114,   100,   114,   125,   114,   129,   100,   129,    98,   126,
     114,   114,   102,   100,   100,   129,   114,   100
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   120,   121,   121,   121,   121,   122,   123,   123,   124,
     124,   125,   125,   125,   126,   126,   127,   127,   127,   128,
     128,   129,   129,   130,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     133,   134,   134,   134,   134,   135,   136,   136,   136,   136,
     136,   137,   137,   138,   138,   139,   139,   140,   140,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   143,   143,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   145,   146,   147,   147,   147,
     148,   148,   148,   149,   149,   149,   150,   150,   151,   152,
     153,   153,   153,   154,   154,   155,   155,   156,   157,   158,
     158,   158,   159,   159,   159,   159,   160,   160,   161,   162,
     163,   163,   163,   164,   164,   165,   165,   165,   165,   165,
     166,   166,   166,   166,   167,   168,   169,   169,   169,   170,
     170,   171,   171,   171,   171,   172,   172,   173,   174,   174,
     174,   175,   175,   175,   175,   175,   175,   176,   176,   176,
     176,   176,   176,   176,   176,   177,   178,   179,   179,   179,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   180,
     180,   180,   180,   180,   181,   181,   181,   181,   182,   183,
     184,   184,   184,   185,   185,   186,   186,   186,   186,   186,
     186,   186,   186,   187,   187,   188,   189,   190,   190,   190,
     191,   191,   191,   191,   191,   191,   192,   192,   192,   192,
     193,   194,   195,   195,   195,   196,   196,   197,   197,   197,
     197,   197,   197,   197,   197,   198,   199,   200,   200,   200,
     201,   201,   201,   201,   202,   202,   203,   204,   205,   205,
     205,   206,   206,   206,   206,   206,   206,   206,   206,   207,
     207,   207,   207,   207,   207,   207,   207,   207,   207,   208
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     1,     1,     1,     1,
       2,     0,     1,     1,     0,     1,     5,    13,    11,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     2,     3,
       6,     4,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     6,     8,     6,     8,     3,     4,     6,     8,     6,
       8,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     9,     1,     1,     1,     1,     3,
       4,     6,     8,     3,     6,     4,     1,     0,     1,     3,
       1,     1,     1,     1,     1,     1,     6,     5,     4,     1,
       0,     1,     3,     1,     1,     6,     5,     4,     1,     0,
       1,     3,     1,     1,     4,     4,     6,     5,     4,     1,
       0,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       6,     5,     1,     1,     4,     1,     0,     1,     3,     1,
       1,     1,     1,     1,     1,     6,     5,     4,     0,     1,
       3,     1,     1,     1,     1,     1,     1,     6,     5,     6,
       5,     5,     5,     1,     1,     1,     4,     0,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     5,     1,     1,     1,     4,
       0,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     5,     1,     4,     0,     1,     3,
       1,     1,     1,     1,     1,     1,     6,     5,     1,     1,
       1,     4,     0,     1,     3,     1,     1,     6,     5,     6,
       5,     4,     1,     4,     1,     1,     4,     0,     1,     3,
       1,     1,     1,     1,     6,     5,     1,     4,     0,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     6,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 528 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2196 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 529 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2202 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 530 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2208 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 531 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2214 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 535 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2220 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 539 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2226 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 540 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2232 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 544 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2238 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 545 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2244 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 549 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2250 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 550 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2256 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 551 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2262 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 555 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2268 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 556 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2274 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 559 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = -1;

			proto_packet_finish();

			realloc_packet();
		}
#line 2286 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 566 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = (yyvsp[-10].number);
			max_cpu = (yyvsp[-8].number);

			if (min_cpu > max_cpu) {
				int tmp = min_cpu;

				min_cpu = max_cpu;
				max_cpu = tmp;
			}

			proto_packet_finish();

			realloc_packet();
		}
#line 2306 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 581 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = (yyvsp[-8].number);

			proto_packet_finish();

			realloc_packet();
		}
#line 2318 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 591 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2324 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 592 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2330 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 596 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2336 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 597 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2342 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 601 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2348 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 605 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[0].number)); }
#line 2354 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 606 "trafgen_parser.y" /* yacc.c:1646  */
    { set_multi_byte((uint8_t *) (yyvsp[0].str) + 1, strlen((yyvsp[0].str)) - 2); }
#line 2360 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 607 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2366 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 608 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2372 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 609 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2378 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 610 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2384 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 611 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2390 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 612 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2396 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 613 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2402 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 614 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2408 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 615 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2414 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 616 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_header_finish(hdr); }
#line 2420 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 617 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2426 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 622 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); }
#line 2432 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 624 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 2438 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 626 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) - (yyvsp[0].number); }
#line 2444 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 628 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * (yyvsp[0].number); }
#line 2450 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 630 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) / (yyvsp[0].number); }
#line 2456 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 632 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) % (yyvsp[0].number); }
#line 2462 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 634 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) & (yyvsp[0].number); }
#line 2468 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 636 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) | (yyvsp[0].number); }
#line 2474 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 638 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) ^ (yyvsp[0].number); }
#line 2480 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 640 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) << (yyvsp[0].number); }
#line 2486 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 642 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) >> (yyvsp[0].number); }
#line 2492 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 644 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = -1 * (yyvsp[0].number); }
#line 2498 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 646 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number);}
#line 2504 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 651 "trafgen_parser.y" /* yacc.c:1646  */
    { set_fill((yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2510 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 656 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[-1].number)); }
#line 2516 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 657 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint16_t __c = cpu_to_be16((uint16_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2526 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 662 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint32_t __c = cpu_to_be32((uint32_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2536 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 667 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint64_t __c = cpu_to_be64((uint64_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2546 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 676 "trafgen_parser.y" /* yacc.c:1646  */
    { set_rnd((yyvsp[-1].number)); }
#line 2552 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 681 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_IP); }
#line 2558 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 683 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP); }
#line 2564 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 685 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP); }
#line 2570 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 687 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP6); }
#line 2576 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 689 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP6); }
#line 2582 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 694 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2588 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 696 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2594 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 701 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2600 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 703 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2606 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 708 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_rnd(); }
#line 2612 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 710 "trafgen_parser.y" /* yacc.c:1646  */
    {
			int i, max = (yyvsp[-1].number);
			for (i = 0; i < max; ++i)
				set_dynamic_rnd();
		}
#line 2622 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 719 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_INC); }
#line 2628 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 721 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_INC); }
#line 2634 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 726 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_DEC); }
#line 2640 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 728 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_DEC); }
#line 2646 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 732 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2652 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 733 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2658 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 734 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2664 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 735 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2670 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 736 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2676 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 737 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2682 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 738 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2688 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 739 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2694 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 740 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2700 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 741 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2706 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 742 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2712 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 743 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2718 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 748 "trafgen_parser.y" /* yacc.c:1646  */
    { field_index_validate(field_expr.field, (yyvsp[-2].number), 1);
		  field_expr.type |= FIELD_EXPR_OFFSET;
		  field_expr.val.func.offset = (yyvsp[-2].number);
		  field_expr.val.func.len = 1; }
#line 2727 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 753 "trafgen_parser.y" /* yacc.c:1646  */
    { field_index_validate(field_expr.field, (yyvsp[-6].number), (yyvsp[-2].number));
		  field_expr.type |= FIELD_EXPR_OFFSET;
		  field_expr.val.func.offset = (yyvsp[-6].number);
		  field_expr.val.func.len = (yyvsp[-2].number); }
#line 2736 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 760 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_NUMB;
		   field_expr.val.number = (yyvsp[0].number); }
#line 2743 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 762 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_MAC;
		memcpy(field_expr.val.mac, (yyvsp[0].mac), sizeof(field_expr.val.mac)); }
#line 2750 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 764 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_IP4_ADDR;
		     field_expr.val.ip4_addr = (yyvsp[0].ip4_addr); }
#line 2757 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 766 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_IP6_ADDR;
		     field_expr.val.ip6_addr = (yyvsp[0].ip6_addr); }
#line 2764 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 768 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			   field_expr.val.func.type = PROTO_FIELD_FUNC_INC;
			   field_expr.val.func.inc = 1; }
#line 2772 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 772 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.inc = (yyvsp[-1].number); }
#line 2780 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 776 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			  field_expr.val.func.type  = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.type |= PROTO_FIELD_FUNC_MIN;
			  field_expr.val.func.min = (yyvsp[-3].number);
			  field_expr.val.func.max = (yyvsp[-1].number);
			  field_expr.val.func.inc = 1; }
#line 2791 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 783 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			  field_expr.val.func.type  = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.type |= PROTO_FIELD_FUNC_MIN;
			  field_expr.val.func.min = (yyvsp[-5].number);
			  field_expr.val.func.max = (yyvsp[-3].number);
			  field_expr.val.func.inc = (yyvsp[-1].number); }
#line 2802 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 789 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_RND;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_RND; }
#line 2809 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 792 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_RND;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_RND;
			  field_expr.val.func.min = (yyvsp[-3].number);
			  field_expr.val.func.max = (yyvsp[-1].number); }
#line 2818 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 799 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2824 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 803 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ETH); }
#line 2830 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 807 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2836 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 808 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2842 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 809 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2848 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 813 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2854 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 814 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2860 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 815 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2866 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 819 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_DST_ADDR); }
#line 2872 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 820 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_SRC_ADDR); }
#line 2878 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 821 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_TYPE); }
#line 2884 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 825 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2890 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 827 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2896 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 831 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2902 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 835 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_PAUSE); }
#line 2908 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 839 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2914 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 840 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2920 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 841 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2926 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 845 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PAUSE_OPCODE); }
#line 2932 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 846 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PAUSE_TIME); }
#line 2938 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 851 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2944 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 853 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2950 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 857 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2956 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 861 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_PFC); }
#line 2962 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 865 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2968 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 866 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2974 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 867 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2980 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 871 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PFC_OPCODE); }
#line 2986 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 872 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PFC_PRIO); }
#line 2992 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 874 "trafgen_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].number) > 7) {
		      yyerror("pfc: Invalid prio(index) parameter");
		      panic("pfc: prio(0)..prio(7) is allowed only\n");
		  }
		  proto_field_set(PFC_PRIO_0 + (yyvsp[-1].number)); }
#line 3002 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 880 "trafgen_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].number) > 7) {
		      yyerror("pfc: Invalid time(index) parameter");
		      panic("pfc: time(0)..time(7) is allowed only\n");
		  }
		  proto_field_set(PFC_TIME_0 + (yyvsp[-1].number)); }
#line 3012 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 889 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3018 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 891 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3024 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 895 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3030 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 899 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_VLAN); }
#line 3036 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 903 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3042 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 904 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3048 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 905 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3054 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 909 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3060 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 914 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_TPID); }
#line 3066 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 915 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_TCI); }
#line 3072 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 916 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_PCP); }
#line 3078 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 917 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_DEI); }
#line 3084 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 918 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_VID); }
#line 3090 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 923 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3096 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 925 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3102 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 927 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, VLAN_TPID, ETH_P_8021Q); }
#line 3108 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 929 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, VLAN_TPID, ETH_P_8021AD); }
#line 3114 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 933 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3120 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 937 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_MPLS); }
#line 3126 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 941 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3132 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 942 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3138 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 943 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3144 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 947 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3150 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 948 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3156 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 952 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_LABEL); }
#line 3162 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 953 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_TC); }
#line 3168 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 954 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_LAST); }
#line 3174 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 955 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_TTL); }
#line 3180 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 960 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3186 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 962 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3192 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 966 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3198 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 970 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3204 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 971 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3210 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 972 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3216 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 977 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_HTYPE); }
#line 3222 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 979 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_PTYPE); }
#line 3228 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 981 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_SHA); }
#line 3234 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 983 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_THA); }
#line 3240 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 985 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_SPA); }
#line 3246 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 987 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_TPA); }
#line 3252 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 992 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3258 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 994 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3264 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 996 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_OPER);
		  proto_field_expr_eval(); }
#line 3271 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 999 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_OPER);
		  proto_field_expr_eval(); }
#line 3278 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1002 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 3284 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1004 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 3290 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1006 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 3296 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1008 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 3302 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1012 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ARP); }
#line 3308 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1016 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3314 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1020 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3320 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1021 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3326 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1022 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3332 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1026 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_VER); }
#line 3338 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1027 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_IHL); }
#line 3344 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1028 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_DADDR); }
#line 3350 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1029 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_SADDR); }
#line 3356 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1030 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_PROTO); }
#line 3362 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1031 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_TTL); }
#line 3368 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1032 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_DSCP); }
#line 3374 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1033 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_ECN); }
#line 3380 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1034 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_TOS); }
#line 3386 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1035 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_LEN); }
#line 3392 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1036 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_ID); }
#line 3398 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1037 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_FLAGS); }
#line 3404 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1038 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_FRAG_OFFS); }
#line 3410 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1039 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_CSUM); }
#line 3416 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1044 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3422 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1046 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3428 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1047 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, IP4_DF, 1); }
#line 3434 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1048 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, IP4_MF, 1); }
#line 3440 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1052 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_IP4); }
#line 3446 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1056 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3452 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1060 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3458 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1061 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3464 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1062 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3470 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1066 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3476 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1067 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3482 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1071 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_VER); }
#line 3488 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1072 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_CLASS); }
#line 3494 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1073 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_FLOW_LBL); }
#line 3500 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1074 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_LEN); }
#line 3506 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1075 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_NEXT_HDR); }
#line 3512 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1076 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_HOP_LIMIT); }
#line 3518 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1077 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_SADDR); }
#line 3524 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1078 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_DADDR) ; }
#line 3530 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1083 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3536 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1085 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3542 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1089 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_IP6); }
#line 3548 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1093 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3554 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1097 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3560 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1098 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3566 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1099 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3572 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1103 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_TYPE); }
#line 3578 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1104 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_CODE); }
#line 3584 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1105 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_ID); }
#line 3590 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1106 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_SEQ); }
#line 3596 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1107 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_MTU); }
#line 3602 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1108 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_REDIR_ADDR); }
#line 3608 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1113 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3614 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1115 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3620 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1117 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV4_TYPE, ICMP_ECHO);
		  proto_hdr_field_set_u8(hdr, ICMPV4_CODE, 0); }
#line 3627 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1120 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV4_TYPE, ICMP_ECHOREPLY);
		  proto_hdr_field_set_u8(hdr, ICMPV4_CODE, 0); }
#line 3634 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1125 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ICMP4); }
#line 3640 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1129 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3646 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1133 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3652 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1134 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3658 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1135 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3664 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1139 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_CODE); }
#line 3670 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1140 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_CSUM); }
#line 3676 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1145 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3682 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1147 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3688 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1149 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_TYPE);
		  proto_field_expr_eval(); }
#line 3695 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1152 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_TYPE);
		  proto_field_expr_eval(); }
#line 3702 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1155 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REQUEST); }
#line 3708 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1157 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REQUEST); }
#line 3714 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1159 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REPLY); }
#line 3720 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1161 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REPLY); }
#line 3726 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1164 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ICMP6); }
#line 3732 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1168 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3738 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1172 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3744 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1173 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3750 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1174 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3756 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1178 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_SPORT); }
#line 3762 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1179 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_DPORT); }
#line 3768 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1180 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_LEN); }
#line 3774 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1181 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_CSUM); }
#line 3780 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1186 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3786 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1188 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3792 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1192 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_UDP); }
#line 3798 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1196 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3804 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1200 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3810 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1201 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3816 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1202 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3822 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1206 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_SPORT); }
#line 3828 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1207 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_DPORT); }
#line 3834 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1208 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_SEQ); }
#line 3840 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1209 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_ACK_SEQ); }
#line 3846 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1210 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_DOFF); }
#line 3852 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1211 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_WINDOW); }
#line 3858 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1212 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_CSUM); }
#line 3864 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1213 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_URG_PTR); }
#line 3870 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1218 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3876 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1220 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3882 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1221 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_CWR, 1); }
#line 3888 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1222 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_ECE, 1); }
#line 3894 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1223 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_URG, 1); }
#line 3900 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1224 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_ACK, 1); }
#line 3906 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1225 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_PSH, 1); }
#line 3912 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1226 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_RST, 1); }
#line 3918 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1227 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_SYN, 1); }
#line 3924 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1228 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_FIN, 1); }
#line 3930 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1232 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_TCP); }
#line 3936 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;


#line 3940 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1235 "trafgen_parser.y" /* yacc.c:1906  */


static void finalize_packet(void)
{
	/* XXX hack ... we allocated one packet pointer too much */
	plen--;
	dlen--;
}

static void dump_conf(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		printf("[%zu] pkt\n", i);
		printf(" len %zu cnts %zu rnds %zu\n",
		       packets[i].len,
		       packet_dyn[i].clen,
		       packet_dyn[i].rlen);

		printf(" payload ");
		for (j = 0; j < packets[i].len; ++j)
			printf("%02x ", packets[i].payload[j]);
		printf("\n");

		for (j = 0; j < packet_dyn[i].clen; ++j)
			printf(" cnt%zu [%u,%u], inc %u, off %jd type %s\n", j,
			       packet_dyn[i].cnt[j].min,
			       packet_dyn[i].cnt[j].max,
			       packet_dyn[i].cnt[j].inc,
			       (intmax_t)packet_dyn[i].cnt[j].off,
			       packet_dyn[i].cnt[j].type == TYPE_INC ?
			       "inc" : "dec");

		for (j = 0; j < packet_dyn[i].rlen; ++j)
			printf(" rnd%zu off %jd\n", j,
			       (intmax_t)packet_dyn[i].rnd[j].off);
	}
}

void cleanup_packets(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		struct packet *pkt = &packets[i];

		if (pkt->len > 0)
			xfree(pkt->payload);

		for (j = 0; j < pkt->headers_count; j++) {
			struct proto_hdr *hdr = pkt->headers[j];

			if (hdr->fields)
				xfree(hdr->fields);
			xfree(hdr);
		}
	}

	free(packets);

	for (i = 0; i < dlen; ++i) {
		free(packet_dyn[i].cnt);
		free(packet_dyn[i].rnd);

		for (j = 0; j < packet_dyn[j].flen; j++)
			xfree(packet_dyn[i].fields[j]);

		free(packet_dyn[i].fields);
	}

	free(packet_dyn);
}

void compile_packets(char *file, bool verbose, unsigned int cpu,
		     bool invoke_cpp, char *const cpp_argv[])
{
	char tmp_file[128];
	int ret = -1;

	if (access(file, R_OK)) {
		fprintf(stderr, "Cannot access %s: %s!\n", file, strerror(errno));
		die();
	}

	memset(tmp_file, 0, sizeof(tmp_file));
	our_cpu = cpu;

	if (invoke_cpp) {
		if (cpp_exec(file, tmp_file, sizeof(tmp_file), cpp_argv)) {
			fprintf(stderr, "Failed to invoke C preprocessor!\n");
			goto err;
		}
		file = tmp_file;
	}

	if (!strncmp("-", file, strlen("-")))
		yyin = stdin;
	else
		yyin = fopen(file, "r");
	if (!yyin) {
		fprintf(stderr, "Cannot open %s: %s!\n", file, strerror(errno));
		goto err;
	}

	realloc_packet();
	if (yyparse() != 0)
		goto err;
	finalize_packet();

	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	if (yyin && yyin != stdin)
		fclose(yyin);

	if (invoke_cpp)
		unlink(tmp_file);
	if (ret)
		die();
}

void compile_packets_str(char *str, bool verbose, unsigned int cpu)
{
	int ret = 1;

	our_cpu = cpu;
	realloc_packet();

	yy_scan_string(str);
	if (yyparse() != 0)
		goto err;

	finalize_packet();
	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	yylex_destroy();

	if (ret)
		die();
}

void yyerror(const char *err)
{
	fprintf(stderr, "Syntax error at line %d, char '%s': %s\n", yylineno, yytext, err);
}
